#include <Windows.h>
#include <stdio.h>
#include "resource.h"

#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")

typedef struct
{
   ULONG pipeNum;
}
BULK_TRANSFER_CONTROL;

HINSTANCE g_hInst;
bool g_bScopeConnected = false;

bool ScopeExecute(HANDLE hScope, const char *commandLine)
{
	char *buffer = new char[512+strlen(commandLine)], *buffPtr = buffer, readBuffer[512];
	int packetLength = 2 + strlen(commandLine), checkSum = 0x43 + 0x11 + (packetLength & 0xFF) + ((packetLength & 0xFF00) >> 8);

	*buffPtr++ = 0x43;
	*buffPtr++ = packetLength & 0xFF;
	*buffPtr++ = (packetLength & 0xFF00) >> 8;
	*buffPtr++ = 0x11;
	
	while(*commandLine != '\0')
	{
		checkSum += *commandLine;
		*buffPtr++ = *commandLine++;
	}

	*buffPtr++ = checkSum & 0xFF;

	BULK_TRANSFER_CONTROL vReq;
	vReq.pipeNum = 0;

	unsigned long byteCount;
	if(DeviceIoControl(hScope, 0x22200D, &vReq, sizeof(BULK_TRANSFER_CONTROL), buffer, packetLength+3, &byteCount, NULL))
	{
		vReq.pipeNum = 1;

		if(DeviceIoControl(hScope, 0x222012, &vReq, sizeof(BULK_TRANSFER_CONTROL), readBuffer, sizeof(readBuffer), &byteCount, NULL))
			return(true);
	}

	return(false);
}

HANDLE ScopeConnect()
{
	HANDLE hScope = CreateFile("\\\\.\\Ezusb-0", GENERIC_WRITE, FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
	return(hScope);
}

int WINAPI DlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_INITDIALOG:
		HANDLE hIcon;
		hIcon = LoadImage(g_hInst, MAKEINTRESOURCE(IDI_ICON), IMAGE_ICON,
			GetSystemMetrics(SM_CXSMICON),
			GetSystemMetrics(SM_CYSMICON),
			0);
		if(hIcon)
		{
			SendMessage(hwndDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);
		}

		HFONT hFont;
		hFont = CreateFont(-MulDiv(8, GetDeviceCaps(GetDC(NULL), LOGPIXELSY), 72), 0, 0, 0,
			FW_BOLD, 0, 0, 0, 0, 0, 0, 0, 0, "");
		if(hFont)
		{
			SendDlgItemMessage(hwndDlg, IDC_DLGHEAD, WM_SETFONT, (WPARAM)hFont, true);
		}
		
		AppendMenu(GetSystemMenu(hwndDlg, false), MF_SEPARATOR, 0, "");
		AppendMenu(GetSystemMenu(hwndDlg, false), MF_BYPOSITION, 200, "About");

		SetTimer(hwndDlg, 1, 500, NULL);
		return(true);

	case WM_CLOSE:
		EndDialog(hwndDlg, 0);
		return(true);

	case WM_COMMAND:
		switch(wParam)
		{
		case IDCANCEL:
			EndDialog(hwndDlg, 0);
			return(true);

		case IDGO:
			KillTimer(hwndDlg, 1);
			EnableWindow(GetDlgItem(hwndDlg, IDGO), 0);
			SetWindowText(GetDlgItem(hwndDlg, IDGO), "Updating...");
			UpdateWindow(GetDlgItem(hwndDlg, IDGO));

			HANDLE hScope = ScopeConnect();
			if(hScope == INVALID_HANDLE_VALUE)
			{
				MessageBox(hwndDlg, "Failed to connect to scope.",
					"Error",
					MB_ICONERROR|MB_OK);
			}
			else
			{
				if(ScopeExecute(hScope, "mv /dst1102b /dst1202b"))
				{
					ScopeExecute(hScope, "reboot");

					MessageBox(hwndDlg, "Success!\n\nYour scope should now reboot in 200 MHz mode.\n\nPlease re-connect the USB cable after the scope has rebooted.\n\nYou can check if the upgrade worked using TTScope.",
						"Success",
						MB_ICONINFORMATION|MB_OK);
				}
				else
				{
					MessageBox(hwndDlg, "Failed to execute upgrade commands.",
						"Error",
						MB_ICONERROR|MB_OK);
				}

				CloseHandle(hScope);
			}

			EndDialog(hwndDlg, 0);

			return(true);
		}

		return(false);

	case WM_SYSCOMMAND:
		if(LOWORD(wParam) == 200)
		{
			MessageBox(hwndDlg, "HanTekway 200 MHz upgrader\n\nUSE AT YOUR OWN RISK.\n\n(c) 2011 patz",
				"About",
				MB_ICONINFORMATION|MB_OK);
			return(true);
		}
		return(false);

	case WM_TIMER:
		HANDLE hScope = ScopeConnect();
		if(hScope == INVALID_HANDLE_VALUE)
		{
			if(g_bScopeConnected)
			{
				EnableWindow(GetDlgItem(hwndDlg, IDGO), false);
				SetWindowText(GetDlgItem(hwndDlg, IDGO), "Please connect scope");
				g_bScopeConnected = false;
			}
		}
		else
		{
			CloseHandle(hScope);

			if(!g_bScopeConnected)
			{
				EnableWindow(GetDlgItem(hwndDlg, IDGO), true);
				SetWindowText(GetDlgItem(hwndDlg, IDGO), "Upgrade to 200 MHz version");
				g_bScopeConnected = true;
			}
		}
		return(true);
	};

	return(false);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	g_hInst = hInstance;
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, DlgProc);
	return(0);
}
